#region Using

using System;
using System.Collections.Generic;
using System.Configuration;
using System.Drawing;
using System.IO;
using System.Web;
using WebApplication2.FileManagement;
using Wisej.Base;
using Wisej.Web;
using Wisej.Web.Ext.RibbonBar;
using Keys = Wisej.Base.Keys;

#endregion

namespace WebApplication2.FileManager
{
    public partial class FileManagement : Form
    {
        readonly FileManagementlvSorter _oLvSorter;

        readonly string[] _forbiddenExtentions;

        public FileManagement()
        {
            InitializeComponent();

            _oLvSorter = new FileManagementlvSorter();
            lvFiles.ItemSorter = _oLvSorter;



        }
        // fired
        private void ribbonBar_ItemClick(object sender, RibbonBarItemEventArgs e)
        {

        }
        //not fired
        private void ribbonBarItemButton1_ItemClicked(object sender, MenuButtonItemClickedEventArgs e)
        {

        }
        //fired
        private void ribbonBar_MenuButtonItemClick(object sender, MenuButtonItemClickedEventArgs e)
        {

        }

        //not fired
        private void RBIDownload_ItemClicked(object sender, MenuButtonItemClickedEventArgs e)
        {

        }

       

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadTreeView();
        }



        private void lvFiles_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetToolbarButtons();

        }

        private void SetToolbarButtons()
        {
            try
            {
                //TODO:
                //tbDelete.Enabled = lvFiles.SelectedItems.Count > 0;
                //tbDownload.Enabled = lvFiles.SelectedItems.Count > 0;
                panPreview.Visible = lvFiles.SelectedItems.Count > 0;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void treeView1_AfterExpand(object sender, TreeViewEventArgs e)
        {
            if (e.Node.IsParent && e.Node.Nodes.Count == 0)
            {
                try
                {
                    LoadOneDirectory((DirectoryInfo) e.Node.Tag, e.Node.Nodes);
                }
                catch
                {
                }

                if (e.Node.Nodes.Count == 0)
                {
                    e.Node.IsParent = false;
                    e.Node.ShowLoader = false;
                }
            }
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {

            try
            {
                lvFiles.Items.Clear();

                SetToolbarButtons();
                if (treeView1.SelectedNode == null)
                {
                    //TODO:
                    //tbDeleteFolder.Enabled = false;
                    //tbCreateFolder.Enabled = false;
                    return;
                }
                //TODO:
                //tbDeleteFolder.Enabled = (treeView1.SelectedNode != treeView1.Nodes[0]);
                //tbCreateFolder.Enabled = true;

                if (treeView1.SelectedNode.Tag is DirectoryInfo)
                {
                    LoadFileList(treeView1.SelectedNode.Tag as DirectoryInfo, "");
                    if (lvFiles.Items.Count > 0)
                        lvFiles.Items[0].Selected = true;
                    else
                        SetToolbarButtons();
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void LoadFileList(DirectoryInfo inDirectory, string inSearchText)
        {
            try
            {
                lvFiles.Items.Clear();

                if (inDirectory == null)
                    return;

                foreach (FileInfo oFile in inDirectory.GetFiles())
                {

                    if (!string.IsNullOrEmpty(inSearchText) &&
                        !oFile.Name.Contains_IgnoreCase(inSearchText))
                        continue;

                    ListViewItem oItem = new ListViewItem {Text = oFile.Name};
                    oItem.SubItems.Add(Math.Round((decimal) oFile.Length / 1024, 1).ToString());
                    oItem.SubItems.Add(oFile.LastWriteTime.ToString());
                    oItem.SubItems.Add(oFile.Extension.Replace(".", ""));
                    oItem.Tag = oFile;
                    lvFiles.Items.Add(oItem);
                }

                lvFiles_SelectedIndexChanged(null, null);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }

        }

        public void AddFileIconToImageList(ImageList imageList, string path)
        {
            lock (imageList)
            {
                string extension = Path.GetExtension(path).ToLower();
                if (imageList.Images.ContainsKey(extension))
                    return;

                Icon icon = System.Drawing.Icon.ExtractAssociatedIcon(path);
                imageList.Images.Add(extension, icon.ToBitmap());
            }
        }

        private void LoadTreeView()
        {
            try
            {
                treeView1.Nodes.Clear();
                DirectoryInfo oDirInfo = new DirectoryInfo(FileManagementSettings.GetPath());
                TreeNode oNode = new TreeNode("MyFiles")
                {
                    Tag = oDirInfo,
                    IsParent = true
                };
                treeView1.Nodes.Add(oNode);

                LoadOneDirectory(oDirInfo, oNode.Nodes);

                oNode.Expand();
                treeView1.SelectedNode = treeView1.Nodes[0];

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void LoadOneDirectory(DirectoryInfo oDirInfo, TreeNodeCollection inNodes)
        {
            foreach (DirectoryInfo oDir in oDirInfo.GetDirectories())
            {
                TreeNode cNode = new TreeNode(oDir.Name)
                {
                    Tag = oDir,
                    IsParent = true,
                    ShowLoader = true
                };
                inNodes.Add(cNode);
            }
        }

        private void lvFiles_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            try
            {
                _oLvSorter.ColumnHeaderClick(lvFiles, e);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void btnSearchGo_Click(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode != null)
                LoadFileList(treeView1.SelectedNode.Tag as DirectoryInfo, txtSearch.Text);

        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode != null)
            {
                txtSearch.Text = "";
                LoadFileList(treeView1.SelectedNode.Tag as DirectoryInfo, "");
            }
        }

        private void txtSearch_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char) Keys.Return && txtSearch.Text != "")
            {
                btnSearchGo.PerformClick();
            }
        }

        private void lvFiles_DoubleClick(object sender, EventArgs e)
        {



        }

        private void ribbonBarGroup2_Click(object sender, EventArgs e)
        {

        }

     
    }
}
